import "./style.css";
import { reactive as D, ref as j, watchEffect as B, onActivated as x, nextTick as F, onBeforeUnmount as I, resolveComponent as f, openBlock as T, createElementBlock as P, createElementVNode as l, createVNode as v, withCtx as W, withDirectives as A, vShow as J, pushScopeId as O, popScopeId as U } from "vue";
import { Button as V } from "@opentiny/vue";
import { VueMonaco as H, CloseIcon as z, LinkButton as R } from "@opentiny/tiny-engine-common";
import { useCanvas as h, useNotify as y, useModal as E, useHelp as Y } from "@opentiny/tiny-engine-meta-register";
import { initCompletion as q } from "@opentiny/tiny-engine-common/js/completion";
import { lint as G, initLinter as K } from "@opentiny/tiny-engine-common/js/linter";
import { insertName as Q, string2Ast as b, formatString as X, ast2String as Z } from "@opentiny/tiny-engine-common/js/ast";
import { constants as $ } from "@opentiny/tiny-engine-utils";
import { isFunction as tt } from "@opentiny/vue-renderless/grid/static";
const { SCHEMA_DATA_TYPE: k } = $, r = D({
  linterWorker: null,
  script: "",
  isChanged: !1,
  hasError: !1,
  editorSelection: null,
  completionProvider: null
}), a = j(null);
let _ = null;
const S = () => {
  var o, n;
  const t = ((n = (o = h()).getSchema) == null ? void 0 : n.call(o)) || {};
  return t.methods = (t == null ? void 0 : t.methods) || {}, t.methods;
}, et = () => h().pageState.pageSchema && Object.keys(S()) || [], M = () => {
  const o = Object.entries(S()).map(([n, e]) => Q(n, e.value)).join(`
`);
  try {
    _ = b(o);
  } catch (n) {
    y({
      type: "error",
      message: `代码静态检查有错误：${n}`
    });
  }
  return o;
}, ot = (t) => {
  if (r.isChanged = t !== r.script, !a.value)
    return;
  const o = a.value.getEditor().getModel();
  G(o, r.linterWorker);
}, nt = ({ name: t, content: o }) => {
  if (!t)
    return;
  const n = S(), e = {
    type: k.JSFunction,
    value: o
  };
  h().updateSchema({ methods: { ...n, [t]: e } });
}, w = () => {
  const { message: t } = E();
  if (!r.isChanged)
    return !1;
  if (r.hasError)
    return t({
      status: "error",
      message: "代码静态检查有错误，请先修改后再保存"
    }), !1;
  const o = a.value.getEditor().getValue(), n = b(o), e = {};
  return n.program.body.forEach((s, i) => {
    var m, u;
    const d = (m = s == null ? void 0 : s.id) == null ? void 0 : m.name;
    (u = n.program.body[i + 1]) != null && u.leadingComments && s.trailingComments === n.program.body[i + 1].leadingComments && delete s.trailingComments;
    const p = X(Z(s).trim(), "javascript");
    d && (e[d] = {
      type: k.JSFunction,
      value: p
    });
  }), h().updateSchema({ methods: e }), h().setSaved(!1), r.isChanged = !1, y({
    type: "success",
    message: "保存成功！"
  }), !0;
}, st = (t) => (o) => {
  const { confirm: n } = E(), e = tt(o) ? o : () => t("close");
  if (!r.isChanged) {
    e(!0);
    return;
  }
  n({
    title: "提示",
    message: "有改动未保存，您确定保存并关闭吗？",
    exec() {
      e(w());
    },
    cancel() {
      e(!0);
    }
  });
}, rt = () => {
  if (!r.editorSelection || !a.value)
    return;
  const t = a.value.getEditor();
  t.setSelection(r.editorSelection), t.focus();
  const o = t.getTopForLineNumber(r.editorSelection.startLineNumber - 1);
  t.setScrollPosition(
    {
      scrollLeft: 0,
      scrollTop: o
    },
    0
  );
}, it = (t) => {
  var e;
  if (!t)
    return;
  const o = _ == null ? void 0 : _.program.body.filter((s) => {
    var i;
    return t === ((i = s == null ? void 0 : s.id) == null ? void 0 : i.name);
  });
  if (o.length === 0)
    return;
  const n = (e = o[0]) == null ? void 0 : e.loc;
  n && (r.editorSelection = {
    startColumn: n.start.column,
    startLineNumber: n.start.line,
    endColumn: n.end.column + 1,
    endLineNumber: n.end.line
  }), r.editorSelection && rt();
}, ct = ({ emit: t }) => (B(() => {
  r.script = M();
}), x(() => {
  F(() => {
    var o;
    r.script = M(), (o = a.value) == null || o.focus(), window.dispatchEvent(new Event("resize"));
  });
}), {
  state: r,
  monaco: a,
  change: ot,
  saveMethods: w,
  close: st(t)
}), lt = (t, o) => {
  const n = t.__vccOpts || t;
  for (const [e, s] of o)
    n[e] = s;
  return n;
}, at = {
  saveMethod: nt,
  highlightMethod: it,
  getMethodNameList: et,
  getMethods: S
}, dt = {
  components: {
    MonacoEditor: H,
    TinyButton: V,
    CloseIcon: z,
    LinkButton: R
  },
  emits: ["close"],
  setup(t, { emit: o }) {
    const n = Y().getDocsUrl("script"), { state: e, monaco: s, change: i, close: d, saveMethods: p } = ct({ emit: o }), m = {
      language: "javascript",
      minimap: {
        enabled: !1
      },
      // 禁用滚动条边边一直显示的边框
      overviewRulerBorder: !1,
      renderLineHighlightOnlyWhenFocus: !0
    }, u = (g) => {
      var c;
      s.value && (e.completionProvider = q(s.value.getMonaco(), (c = s.value.getEditor()) == null ? void 0 : c.getModel()), e.linterWorker = K(g, s.value.getMonaco(), e));
    };
    return I(() => {
      var g, c, C;
      (g = e.completionProvider) == null || g.forEach((N) => {
        N.dispose();
      }), (C = (c = e.linterWorker) == null ? void 0 : c.terminate) == null || C.call(c);
    }), {
      state: e,
      monaco: s,
      options: m,
      close: d,
      change: i,
      saveMethods: p,
      editorDidMount: u,
      docsUrl: n
    };
  }
}, L = (t) => (O("data-v-1019d3e2"), t = t(), U(), t), mt = { class: "plugin-page-js-container" }, ut = { class: "code-edit-head" }, pt = { class: "head-left" }, ht = /* @__PURE__ */ L(() => /* @__PURE__ */ l("span", { class: "title" }, "页面 JS", -1)), gt = { class: "head-right" }, ft = /* @__PURE__ */ L(() => /* @__PURE__ */ l("span", null, "保存", -1)), vt = { class: "dots" }, _t = { class: "code-edit-content" };
function St(t, o, n, e, s, i) {
  const d = f("link-button"), p = f("tiny-button"), m = f("close-icon"), u = f("monaco-editor");
  return T(), P("div", mt, [
    l("div", ut, [
      l("div", pt, [
        ht,
        v(d, { href: e.docsUrl }, null, 8, ["href"])
      ]),
      l("div", gt, [
        v(p, {
          type: "primary",
          class: "save-btn",
          onClick: e.saveMethods
        }, {
          default: W(() => [
            ft,
            A(l("span", vt, null, 512), [
              [J, e.state.isChanged]
            ])
          ]),
          _: 1
        }, 8, ["onClick"]),
        v(m, { onClose: e.close }, null, 8, ["onClose"])
      ])
    ]),
    l("div", _t, [
      v(u, {
        ref: "monaco",
        value: e.state.script,
        options: e.options,
        onChange: e.change,
        onEditorDidMount: e.editorDidMount
      }, null, 8, ["value", "options", "onChange", "onEditorDidMount"])
    ])
  ]);
}
const Ct = /* @__PURE__ */ lt(dt, [["render", St], ["__scopeId", "data-v-1019d3e2"]]), Mt = {
  id: "engine.plugins.pagecontroller",
  title: "页面 JS",
  type: "plugins",
  icon: "plugin-icon-js",
  align: "top",
  confirm: "close"
  // 当点击插件栏切换或关闭前是否需要确认, 会调用插件中confirm值指定的方法，e.g. 此处指向 close方法，会调用插件的close方法执行确认逻辑
}, xt = {
  ...Mt,
  apis: at,
  entry: Ct
};
export {
  xt as default
};
